﻿#!/usr/bin/python

#StallmanBot - An IRC bot meant to imitate the likeness of the venerable StallmanBot
#(c) Ironchew 2010 with modifications (c) 2011 Miga, released under the same license
#Kulor has some copyrights in there too proly huh?
#Author(s): Ironchew, Miga, Kulor
#Version 0.1 alpha

#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


#Need this for a sleep function so far
import time
#Need this for intercepting keyboard interrupts
import signal
#Need this for...something I can't remember at the moment
import sys
#Need this for networking!
import socket
#Need this 'cuz I don't feel like doing dictionaries to a file manually
import pickle
#And this stupid thing for deleting the file
import os
#'Cuz you always need some random numbers, baby
import random

#Some predefines to make everybody's life easier
BOTNICK = 'StallmanBot'
USERNAME = 'bash'
SERVER = 'irc.esper.net'
PORT = 6667
CHANNEL = '#botb'
OWNER = 'kulor'

#Initialize the socket descriptor "s"
s = socket.socket()

#Dictionary of app:freedomvalue, for !add and !isfree
appList = {}

#Another dictionary, this time author:time, for !seen
authorList = {}

#Fill it with the contents of the freelist.txt file
if not os.path.isfile("freelist.txt"):
    with open("freelist.txt", 'w') as f:
        print "freelist.txt: File didn't exist! Generating new one."
else:
    size = os.path.getsize("freelist.txt")
    print size
    if size == 0:
        with open("freelist.txt", 'w') as f:
            print "freelist.txt: File empty! Generating new one."
    else:
        with open("freelist.txt", 'r+') as f:
            appList = pickle.load(f)
            authorList = pickle.load(f)
    

#Initializing our argument variables, just to be sure they exist
arg1 = ''
arg2 = ''
gotbacon = False

#initializing the time store-er for potentially spammy commands
linuxdelayvalue = 0
singdelayvalue = 0
propdelayvalue = 0
balmdelayvalue = 0
staldelayvalue = 0
truckdelayvalue = 0
timedelayvalue = 0
quotedelayvalue = 0
starttime = int(time.time()) #Along with some for the !time command
currenttime = 0

#Connect that socket!  (connect() takes a duple)
if s.connect_ex((SERVER,PORT)) != 0:
    print "Could not connect to server.  Exiting...\n"
    exit(0)
else:
    print "Connection succeeded!"

#send() and recv() will be how we send across the socket and receive from the socket, respectively
#send() will most likely send everything in one packet, so we won't worry about it unless something goes wrong
#recv(), on the other hand, gets a bunch a...clutter 'n mess from the server that can take multiple packets to send,
#so we need to add recv() to the buffer until we're reasonably certain that the server isn't sending us incoming packets.
#recv() will accept 4096 bytes maximum from the socket at a time, so as to avoid flooding issues.

#Wait for server to respond
#We're using buf to hold stuff that we receive
#default should be 4096
buf = ''
while buf.find ('Looking up your hostname...') == -1:
    buf += s.recv(4096)

buf = ''

#Send identification to server
s.send('NICK '+BOTNICK+'\r\n')
s.send('USER '+USERNAME+' 0 * :'+USERNAME+'\r\n')

buf = ''

#Wait for the initial PING test
#PING structure -- PING :RANDOMSTRING
#Respond with   -- PONG :SAMESTRING
while True:
    buf += s.recv(4096)
    #FreeNode sends out a lot of the clutter 'n mess...we gotta fix that. After it pongs, we sleep for two
    #seconds to wait out the clutterstorm. There's probably a better way to do this, but I suck at Python. -Miga
    time.sleep(2)
    index = buf.find('PING')
    if index != -1:
        #PING was found
        #Extract the substring beginning with 'PING' and split off the key
        line = buf[index:].split(' ',1)
        print line[0]+' '+line[1]+'\n'
        #Send PONG with same key
        s.send('PONG '+line[1]+'\r\n')
        print 'Responded to PONG '+line[1]+'\n'
        break

buf = ''

#Wade through da clutter 'n mess that the IRC server will inevitably throw at us before we can do anything
while buf.find('MODE '+BOTNICK+' :+i') != -1:
    buf += s.recv(4096)

#We want to join a channel
s.send('JOIN '+CHANNEL+'\r\n')
#Wade through the clutter 'n mess of the channel (it's ignored, but we might want to implement it sometime...)
#
#Again, we sleep for two seconds here because of recent FursonaNet changes that still sends clutter after the
#first sleep stage. After this, there's guaranteed to be no clutter getting to GNUBot. -Miga
time.sleep(2)
s.recv(4096)

#Send a greeting to everybody
#Outgoing message structure:
#Public message to channel -- 'PRIVMSG #CHANNEL :MESSAGE\r\n'
#Private message to nick   -- 'PRIVMSG NICK :MESSAGE\r\n'
## s.send('PRIVMSG '+CHANNEL+' :GNUBot is undergoing maintenance.\r\n')
s.send('PRIVMSG '+CHANNEL+' :Greetings, hackers.\r\n')

#Main loop
while True:
    try:
        #Wait for a message
        buf = s.recv(4096)
        #Strip off trailing whitespace
        buf = buf.rstrip()
        
        #We want to respond to PINGs to let the server know we're still connected
        if buf.find('PING') != -1:
            print 'PING!'
            line = buf.split(' ',1)
            s.send('PONG '+line[1]+'\r\n')
            print 'PONG! '+line[1]

        #This is the workhorse.  We want to interpret messages sent to us in these formats:
        #Public message to board  -- :nick!user@domain PRIVMSG #CHANNEL :MESSAGE
        #Private message to me    -- :nick!user@domain PRIVMSG StallmanBot :MESSAGE
        
        #Other possible incoming messages:
        #Somebody joined the board   :nick!user@domain JOIN :#CHANNEL
        #Somebody changed their nick :nick!user@domain NICK :NEWNICK
        #Somebody left the board  -- :nick!user@domain PART #CHANNEL :LEAVEMESSAGE
        #Somebody quit the board  -- :nick!user@domain QUIT :QUITMESSAGE
        #Somebody kicked me       -- :nick!user@domain KICK #CHANNEL StallmanBot :KICKMESSAGE

        #This will make GNUBot rejoin if he gets kicked, also saving freelist from being lost in RAM from just that.
        if buf.find('KICK') != -1:
            if buf.find('StallmanBot') != -1:
                s.send('JOIN '+CHANNEL+'\r\n')
                s.send('PRIVMSG '+CHANNEL+' :You can\'t kick freedom, you know.\r\n')

        elif buf.find('JOIN') != -1:
            line = buf.split()
            author = line[0]
            if author.find('!') != -1:
                strloc = author.index('!')  #Find the ! in the nick!~username@ip32981739vfdbvd craziness
                author = author[:strloc]    #Clear out the rest of that clutter 'n' mess
                author = author.translate(None, ':')    #and get rid of that thing too
                author = author.lower()
            else:
                author = "none"
            s.send('PRIVMSG '+author+' :\001VERSION\001\r\n')

        elif buf.find('NOTICE') != -1:
            line = buf.split()
            print line
            if line.count('Windows') > 0:
                if line.count('XP') > 0:
                    s.send('PRIVMSG '+CHANNEL+' :Windows XP is everything that\'s wrong with software today.\r\n')
                    time.sleep(3)
                    s.send('PRIVMSG '+CHANNEL+' :s/today/10 years ago/g\r\n')
                if line.count('Vista') > 0:
                    s.send('PRIVMSG '+CHANNEL+' :You should be feeling 7 times more ashamed for supporting Microsoft\'s latest atrocity against Freedom.\r\n')
                if line.count('7') > 0:
                    s.send('PRIVMSG '+CHANNEL+' :Hey Kulor, it might be time to update me.\r\n')
            if line.count('Ubuntu') > 0 or line.count('Ubuntu\x01'):
                s.send('PRIVMSG '+CHANNEL+' :You\'re on the right track, but Ubuntu still contains proprietary elements. Might I suggest gNewSense in its place?\r\n')
            if line.count('HydraIRC') > 0:
                s.send('PRIVMSG '+CHANNEL+' :See, HydraIRC is exactly the sort of thing I mean when I say \'free as in free beer\'.\r\n')
            if line.count('Android') > 0:
                s.send('PRIVMSG '+CHANNEL+' :If you have a portable surveillance and tracking device, please turn it off. They have already tracked you in here, they already know you are listening to me; so, there is no need for you to keep it on.\r\n')
            if line.count('gNewSense') > 0:
                s.send('PRIVMSG '+CHANNEL+' :\001ACTION beard ruffles in approval\001\r\n')
                
        elif buf.find('PRIVMSG') != -1:
            #Split apart the message fields -- line is now a list with each part of the line as an element in the list!
            line = buf.split()
            print line
            #Isolate the message body
            query = line[3]
            command = line[2]
            author = line[0]
            #Convert everything to lowercase
            query = query.lower()
            #Get the clean version of the message author nick
            if author.find('!') != -1:
                strloc = author.index('!')  #Find the ! in the nick!~username@ip32981739vfdbvd craziness
                author = author[:strloc]    #Clear out the rest of that clutter 'n' mess
                author = author.translate(None, ':')    #and get rid of that thing too
                author = author.lower()
            else:
                author = "none"
            print author
            #And while we're here, let's record it
            authorList[author] = int(time.time())
            #Check to see if there's an argument, and grab it if there is
            if len(line) > 4:
                arg1 = line[4]
                arg1 = arg1.lower()
                print arg1
                #While we're here, why not check for a second argument as well
                if len(line) > 5:
                    arg2 = line[5]
                    arg2 = arg2.lower()
                    print arg2
            #Parse for commands
            if query == ':!isfree':
                print "Finding..."
                if arg1 in appList:
                    freedomLevel = appList[arg1]
                    print freedomLevel
                    if freedomLevel == 0:
                        s.send('PRIVMSG '+CHANNEL+' :'+arg1+'? Free? You\'re kidding me.\r\n')
                    if freedomLevel == 1:
                        s.send('PRIVMSG '+CHANNEL+' :I shake my beard in disapproval at '+arg1+'.\r\n')
                    if freedomLevel == 2:
                        s.send('PRIVMSG '+CHANNEL+' :If by \'free\' you mean \'a bastardization of what GNU set out to do\', then yeah, '+arg1+' is \'free\'.\r\n')
                    if freedomLevel == 3:
                        s.send('PRIVMSG '+CHANNEL+' :'+arg1+' is a better option than most, but contains proprietary elements. Might I suggest a more free alternative?\r\n')
                    if freedomLevel == 4:
                        s.send('PRIVMSG '+CHANNEL+' :I fully approve of '+arg1+'.\r\n')
                    if freedomLevel == 999:
                        s.send('PRIVMSG '+CHANNEL+' :Let\'s just say that '+arg1+'...well, he watches.\r\n')
                else:
                    s.send('PRIVMSG '+CHANNEL+' :'+arg1+'? Doesn\'t ring a bell...\r\n')
            if query == ':!add':
                print "Adding..."
                try:
                    if int(arg2) < 5 and int(arg2) > -1 or int(arg2) == 999:
                        appList[str(arg1)] = int(arg2)
                        print appList
                        s.send('PRIVMSG '+CHANNEL+' :Very well, I have added '+str(arg1)+'.\r\n')
                    else:
                        s.send('PRIVMSG '+CHANNEL+' :Freedom values may be between 0 and 4.\r\n')
                except ValueError:
                    s.send('PRIVMSG '+CHANNEL+' :I don\'t quite understand.\r\n')
            if query == ':!list':
                s.send('PRIVMSG '+CHANNEL+' :'+str(appList)+'\r\n')
            if query == ':!gplfind':
                s.send('PRIVMSG '+CHANNEL+' :gplfind: Not yet implemented.\r\n')
            if query == ':!sing':
                if singdelayvalue < (time.time() - 600):
                    s.send('PRIVMSG '+CHANNEL+' :\001ACTION clap clapclap clap clap clapclap clap\001\r\n')
                    time.sleep(2)
                    s.send('PRIVMSG '+CHANNEL+' :\001ACTION slap slapslap slap slap slapslap slap\001\r\n')
                    time.sleep(2)
                    s.send('PRIVMSG '+CHANNEL+' :Join us now and share the software!\r\n')
                    time.sleep(2)
                    s.send('PRIVMSG '+CHANNEL+' :You\'ll be free, hackers!  You\'ll be...free~~e~eeee!\r\n')
                    time.sleep(2)
                    s.send('PRIVMSG '+CHANNEL+' :Join us now and share the software!\r\n')
                    time.sleep(2)
                    s.send('PRIVMSG '+CHANNEL+' :You\'ll be free, hackers!  You\'ll be...freeeeee.\r\n')
                    singdelayvalue = time.time()
                else:
                    s.send('PRIVMSG '+CHANNEL+' :I\'m a programmer, not a performer.\r\n')
            if query == ':!quit':
                if author == OWNER:
                    s.send('PRIVMSG '+CHANNEL+' :As you wish. Farewell!\r\n')
                    raise KeyboardInterrupt
                else:
                    s.send('PRIVMSG '+CHANNEL+' :I don\'t feel like it.\r\n')
            if query == ':!time':
                if timedelayvalue < (time.time() - 20):
                    currenttime = int(time.time())
                    s.send('PRIVMSG '+CHANNEL+' :Seconds since the UNIX epoch: '+str(currenttime)+'\r\n')
                    s.send('PRIVMSG '+CHANNEL+' :I\'ve been running for '+str(currenttime - starttime)+' seconds.\r\n')
                    timedelayvalue = time.time()
            if query == ':!seen':
                if arg1 == author:
                    s.send('PRIVMSG '+CHANNEL+' :You\'re talking right now, silly!\r\n')
                elif arg1 == "stallmanbot":
                    s.send('PRIVMSG '+CHANNEL+' :...yes, I have seen that individual.\r\n')
                elif arg1 == "":
                    s.send('PRIVMSG '+CHANNEL+' :Have I seen whom?\r\n')
                else:
                    if arg1 in authorList:
                        currenttime = int(time.time())
                        s.send('PRIVMSG '+CHANNEL+' :The last time '+str(arg1)+' said anything was '+str(currenttime - authorList[str(arg1)])+' seconds ago.\r\n')
                    else:
                        s.send('PRIVMSG '+CHANNEL+' :I\'ve never seen that person before.\r\n')
            #this one might not have lastibility, as it relies on BaconBot
            if query == ':!givestallmanapieceofbacon':
                s.send('PRIVMSG '+CHANNEL+' :!bacon\r\n')
                gotbacon = True
            #One more check to see if other things were said
            print len(line)
            #Trash all the punctuation and capitalization
            for i in range(len(line)):
                line[i] = line[i].translate(None, '~`!@#$%^&*()_+-=\'\\:;",.<>/?')
                line[i] = line[i].lower()
                #print '+'+line[i]          #Fills up the terminal pretty fast, but good for debug
            #Check the resulting text
            if line.count('linux') > 0:
                if line.count('gnu') < 1:
                    if line.count('kernel') < 1:
                        if linuxdelayvalue < (time.time() - 600):
                            s.send('PRIVMSG '+CHANNEL+' :I\'d just like to interject for a moment. What you\'re referring to as Linux, is in fact, GNU/Linux, or as I\'ve recently taken to calling it, GNU plus Linux.\r\n')
                            s.send('PRIVMSG '+CHANNEL+' :Linux is not an operating system unto itself, but rather another free component of a fully functioning GNU system made useful by the GNU corelibs, shell utilities and vital system components comprising a full OS as defined by POSIX.\r\n')
                            linuxdelayvalue = time.time()
                        else:
                            s.send('PRIVMSG '+CHANNEL+' :\001ACTION cough cough\001\r\n')
            if line.count('proprietary') > 0:
                if propdelayvalue < (time.time() - 600):
                    s.send('PRIVMSG '+CHANNEL+' :Proprietary software makes me physically ill.\r\n')
                    propdelayvalue = time.time()
            if line.count('ballmertan') > 0:
                if balmdelayvalue < (time.time() - 600):
                    s.send('PRIVMSG '+CHANNEL+' :http://kulor.arnoldascher.com/Ballmer.jpg\r\n')
                    balmdelayvalue = time.time()
            if line.count('stallmanchan') > 0:
                if staldelayvalue < (time.time() - 600):
                    s.send('PRIVMSG '+CHANNEL+' :http://kulor.arnoldascher.com/Stallmanchan.png\r\n')
                    s.send('PRIVMSG '+CHANNEL+' :うそッ！\r\n') #UTF-8, happy now IDLE?
                    staldelayvalue = time.time()
            if line.count('truck') > 0 or line.count('trucks') > 0:
                if truckdelayvalue < (time.time() - 600):
                    s.send('PRIVMSG '+CHANNEL+' :He watches.\r\n')
                    truckdelayvalue = time.time()
            #Now to throw out a random quote when Stallmanbot's name is said
            #Ideally this should eventually read from a file containing quotes
            if line.count('stallmanbot') > 0 or line.count('stallmanbots') > 0:
                if quotedelayvalue < (time.time() - 20):
                    if not os.path.isfile("quotelist.txt"):
                        with open("quotelist.txt", 'w') as f:
                            print "quotelist.txt: File didn't exist! Generating new one."
                            f.write("Stop pestering me, I'm trying to program. (put some quotes in quotelist.txt!)")
                    else:
                        size = os.path.getsize("quotelist.txt")
                        print size
                        if size == 0:
                            with open("quotelist.txt", 'w') as f:
                                print "quotelist.txt: File empty! Generating new one."
                                f.write("Stop pestering me, I'm trying to program. (put some quotes in quotelist.txt!)")
                        else:
                            with open("quotelist.txt", 'r+') as f:
                                f.seek(f.tell() + random.randint(0, size - 1) % size)
                                quote = f.readline() #Don't use this one, it's in the middle of a line, maybe
                                quote = f.readline()
                                if quote == '':     #If it hits the end of the file, wrap around to the first quote
                                    f.seek(0)
                                    quote = f.readline()
                                s.send('PRIVMSG '+CHANNEL+' :'+quote+'\r\n')
                                quotedelayvalue = time.time()
                
            #lol
            if author == "youtubebot":
                s.send('PRIVMSG '+CHANNEL+' :\001ACTION grumble grump other bot...\001\r\n')
            if author == "baconbot":
                if gotbacon == True:
                    s.send('PRIVMSG '+CHANNEL+' :Ah, thank you.\r\n')
                    time.sleep(2)
                    s.send('PRIVMSG '+CHANNEL+' :\001ACTION HARF SNARF NOM\001\r\n')
                    gotbacon = False
    #Bail on Ctrl-C
    except KeyboardInterrupt:
        s.send('QUIT :http://www.fsf.org/\r\n')
        with open("freelist.txt", 'w') as f:
            #print f.readlines()
            pickle.dump(appList, f)
            pickle.dump(authorList, f)
        break
s.close()
